



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>面试问题5：const 与 define 宏定义之间的区别</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">面试问题5：const 与 define 宏定义之间的区别</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 18:54:05 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>问题描述：const 与 define 宏定义之间的区别</strong></p>
<div>(1) 编译器处理方式不同<br />&nbsp; &nbsp; &nbsp;define宏是在预处理阶段展开；<br />&nbsp; &nbsp; &nbsp;const常量是编译运行阶段使用；</p>
<p>(2) 类型和安全检查不同<br />&nbsp; &nbsp; &nbsp;define宏没有类型，不做任何类型检查，仅仅是展开；<br />&nbsp; &nbsp; &nbsp;const常量有具体的类型，在编译阶段会执行类型检查；</p>
<p>(3) 存储方式不同<br />&nbsp; &nbsp; &nbsp;define宏仅仅是展开，有多少地方使用，就展开多少次，不会分配内存；<br />&nbsp; &nbsp; &nbsp;const常量会在内存中分配(可以是堆中也可以是栈中)；</div>
<div>
<p>利用宏的优点：</p>
<p>1)让代码更简洁明了</p>
<p>一般来说，宏的名字更要注重有明确直观的意义，有时宁可让它长点。</p>
<p>2)方便代码维护</p>
<p>对宏的处理，在编译过程中称为&ldquo;预处理&rdquo;。也就是说在正式编译前，编译器必须先将代码出现的宏，用其相应的宏值替换，这个过程有点你我在文字处理软件中的查找替换。所以在代码中使用宏表达常数，归根结底还是使用了立即数，并没有明确指定这个量的类型。</p>
<p>利用const：</p>
<p>常量定义的格式为：</p>
<p>const 数据类型 常量名 = 常量值;</p>
<p>而const定义的常量具有数据类型，定义数据类型的常量便于编译器进行数据检查，使程序可能出现错误进行排查。常量必须一开始就指定一个值，然后，在以后的代码中，我们不允许改变此常量的值。</p>
<p>define定义表达式时要注意&ldquo;边缘效应&rdquo;，例如如下定义：<br />#define N 2+3 //我们预想的N值是5，我们这样使用N，int a = N/2; //我们预想的a的值是2.5，可实际上a的值是3.5原因在于在预处理阶段，编译器将 a = N/2处理成了 a = 2+3/2；这就是宏定义的字符串替换的&ldquo;边缘效应&rdquo;因此要如下定义：#define N (2+3)</p>
<p>举例：</p>
<div>
<pre class="prettyprint linenums"> #include &lt;bits/stdc++.h&gt;<br />
 #define N 2+3<br />
 using namespace std;

 int main()<br />
 {<br />
     double ans = N/2.0;<br />
     printf("%lf\n" ,ans );<br />
 }</pre>
</div>
<p>GCC运行结果：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/834545/201603/834545-20160328193255863-217448341.jpg" /></p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8kw2r8j.html">Golang接口&lpar;interface&rpar;三个特性&lpar;译文&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy10dmq.html">scp 从远程服务器上一下载文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxe27z8.html">Makefile相关知识</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jrrn0q.html">Droid4x安装busybox</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmgzz09.html">java识别文件或字符串的编码格式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z16z639.html">FFT Golang 实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvoozzq.html">Mvc基础&lpar;1&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z1r529.html">502 bad gateway是什么意思</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1peyj9.html">gulp&plus;webpack&plus;vue</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzlo0l8.html">setTimeout 与 Event Loop 浅析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjpozg8.html">cadence元件放置方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp657jq.html">I Think I Need a Houseboat POJ - 1005</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4173m9.html">编写一个简单的基于jmespath 的prometheus exporter</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw7y2z8.html">《DSP using MATLAB》Problem 7&period;9</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjvr2e9.html">可视化的fineBI很高大上 使用简单，简单操作了一下，拖一拖就行，收费 只能看一下人家的demo 网站 http&colon;&sol;&sol;demo&period;finebi&period;com&sol;webroot&sol;decision&num;directory</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj7yr09.html">leetcode-algorithms-5 Longest Palindromic Substring</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2l01j9.html">解决You have an error in your SQL syntax&semi; check the manual that corresponds to your MySQL server version for the right syntax to use near &amp;&num;39&semi;order &lpar;order&lowbar;name&comma; customer&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd17wz9.html">魔方Newlife&period;Cube权限系统的使用及模版覆盖详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gp4g3e9.html">含有虚函数的类sizeof大小</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4poov3q.html">PHP命名规则</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/2q7o6m18.html">&period;net登录的一般模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kjypr9.html">微软版的SqlHelper&period;cs类</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyymvxq.html">DataTable转实体Model，DataRow转实体Model，DataTable转泛型T，DataRow转泛型T</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyym2jq.html">鼠标移到导航上面 当前的LI变色 处于当前的位置</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdwmxx9.html">header&lpar;&amp;&num;39&semi;Location&colon;&amp;&num;39&semi;&period;C&lpar;&amp;&num;39&semi;VIP&lowbar;HX&amp;&num;39&semi;&rpar;&period;&amp;&num;39&semi;&sol;CmdId&sol;&amp;&num;39&semi;&period;&dollar;CmdId&period;&amp;&num;39&semi;&sol;user&lowbar;id&sol;&amp;&num;39&semi;&period;&dollar;user&lowbar;id&period;&amp;&num;39&semi;&sol;Token&sol;&amp;&num;39&semi;&period;&dollar;Token&rpar;&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlly26q.html">Java Web项目RSA加密</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kj3l79.html">Hibernate实现有两种配置，xml配置与注释配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r5jx7q.html">python之进程与线程</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qx2kwj8.html">很漂亮的用户登录界面HTML模板</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyv1gxq.html">【转】【译】JavaScript魔法揭秘--探索当前流行框架中部分功能的处理机制</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
